# Maksymalna liczba, o którą może pojawić się zapytanie.
LIMIT = 5000000000


# Funkcja f zdefiniowana w zadaniu - zwraca sumę cyfr liczby n.
def f(n):
  # Deklarujemy zmienną na sumę.
  suma = 0
  # Dopóki liczba n nie jest równa zero,
  while n != 0:
    # dodaj do sumy ostatnią cyfrę (resztę z dzielenie przez 10)
    suma += n % 10
    # i usuń tę cyfrę (podziel tę liczbę przez 10).
    n //= 10

  # Na końcu zwróć sumę.
  return suma


# Funkcja g zdefniowana w zadaniu, zwraca n + f(n) * f(n).
def g(n):
  # Zapisujemy f(n) jako zmienną, aby nie liczyć tej funkcji dwukrotnie.
  fn = f(n)
  # Zwracamy wartość funkcji g dla liczby n.
  return n + fn * fn


def main():
  # Deklarujemy i wczytujemy liczbę zapytań.
  q = int(input())

  # Deklarujemy wektor na zapytania.
  # Zapytania będziemy trzymali jako parę określającą liczbę, o którą
  # pytamy, a także indeks zapytania (które to było zapytanie w kolejności).
  M = []
  for i in range(q):
    m = int(input())
    M.append((m, i))

  # Sortujemy wszystkie zapytania.
  M.sort()

  # Deklarujemy wektor na nasze odpowiedzi, które będziemy uzupełniać.
  odpowiedz = [False for _ in range(q)]

  # Zaczynamy od n = 1.
  n = 1

  # Deklarujemy wskaźnik na wektor M, początkowo równy zero.
  wsk_m = 0

  # Dopóki n jest nie większe niż nasz limit:
  while n <= LIMIT:
    # Sprawdzamy czy aktualna wartość w wektorze M jest mniejsza od n.
    while wsk_m < q and M[wsk_m][0] < n:
      # Jeżeli tak, to musimy przesunąć nasz wskaźnik w prawo.
      wsk_m += 1

    # Sprawdzamy teraz czy aktualna wartość w wektorze M jest równa n.
    while wsk_m < q and M[wsk_m][0] == n:
      # Jeżeli tak, to daną wartość możemy uzyskać w procesie,
      # dlatego ustawiamy odpowiednią odpowiedź na true.
      odpowiedz[M[wsk_m][1]] = True
      # Następnie przesuwamy wskaźnik w prawo.
      wsk_m += 1

    # Zamieniamy n na g(n).
    n = g(n)


  # Finalnie, dla wszystkich zapytań wypisujemy odpowiednie odpowiedzi.
  for i in range(q):
    if odpowiedz[i]: print("TAK")
    else: print("NIE")


main()
